CREATE TABLE IF NOT EXISTS `#__ldlinks` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `catid` int(11) NOT NULL default '0',
  `title` varchar(250) NOT NULL default '',
  `url` varchar(250) NOT NULL default '',
  `thumburl` varchar(250) NOT NULL default '',
  `image` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `description_long` text NOT NULL, 
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL default '0',
  `rating` float NOT NULL default '0',
  `votes` int(11) NOT NULL default '0',
  `published` tinyint(1) NOT NULL default '0',
  `checked_out` int(11) NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL default '0',
  `params` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `catid` (`catid`,`published`)
) TYPE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__ldcats` (
  `id` int(11) NOT NULL auto_increment,
  `parent_id` int(11) NOT NULL default '0',
  `title` varchar(50) NOT NULL default '',
  `name` varchar(255) NOT NULL default '',
  `image` varchar(100) NOT NULL default '',
  `description` text NOT NULL,
  `published` tinyint(1) NOT NULL default '0',
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `editor` varchar(50) default NULL,
  `ordering` int(11) NOT NULL default '0',
  `access` tinyint(3) unsigned NOT NULL default '0',
  `count` int(11) NOT NULL default '0',
  `params` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `cat_idx` (`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`)
) TYPE=MyISAM;


CREATE TABLE IF NOT EXISTS `#__ldlog` (
  `log_ip` varchar(255) NOT NULL default '',
  `log_type` varchar(32) NOT NULL default '',
  `user_id` int(11) NOT NULL default '0',
  `log_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `link_id` int(11) NOT NULL default '0',
  KEY `link_id2` (`link_id`,`log_ip`),
  KEY `link_id1` (`link_id`,`user_id`)
) TYPE=MyISAM;


CREATE TABLE IF NOT EXISTS `#__ldcomment` (
  `rev_id` int(11) NOT NULL auto_increment,
  `link_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `type` tinyint(4) NOT NULL default '0',
  `guest_name` varchar(255) NOT NULL default '',
  `rev_title` varchar(255) NOT NULL default '',
  `rev_text` text NOT NULL,
  `rev_date` date NOT NULL default '0000-00-00',
  `rev_approved` tinyint(4) NOT NULL default '1',
  `published` tinyint(1) NOT NULL,
  `checked_out` int(11) NOT NULL,
  `checked_out_time` datetime NOT NULL,
  PRIMARY KEY  (`rev_id`),
  KEY `rev_id` (`rev_id`),
  KEY `link_id` (`link_id`,`rev_approved`)
) TYPE=MyISAM;


CREATE TABLE IF NOT EXISTS `#__ldgroups` (
  `groups_id` tinyint(11) NOT NULL auto_increment,
  `groups_name` text NOT NULL,
  `groups_description` longtext NOT NULL,
  `groups_access` tinyint(4) NOT NULL default '0',
  `groups_members` text NOT NULL,
  PRIMARY KEY  (`groups_id`)
) TYPE=MyISAM AUTO_INCREMENT=8;

