<?php defined('_JEXEC') or die( 'Restricted access' );

/**
 * @version 2.0 $Id: weblinks.php,v 1.16 2011-03-25 22:38:18 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport('joomla.application.component.model');

class LinkDirectory2ModelWeblinks extends JModel {
	private $_data = null;
	private $_total = null;
	private $_pagination = null;

	/**
	 */
	public function __construct(){
		parent::__construct();
		
		global $option;
		$mainframe = JFactory::getApplication();
		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'.links.limitstart', 'limitstart', 0, 'int' );
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}

	/**
	 */
	public function getData() {
		if (empty($this->_data)) {
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}
		return $this->_data;
	}

	/**
	 */
	public function getTotal() {
		if (empty($this->_total)) {
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}
		return $this->_total;
	}

	/**
	 */
	public function getPagination() {
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$total = $this->getTotal();
			$limitstart = $this->getState('limitstart');
			$limit = $this->getState('limit');
			if ($limitstart > $total) {
				$limitstart = (int)(ceil($total / $limit) - 1) * $limit;
			}
			$this->_pagination = new JPagination( $total, $limitstart , $limit );
		}
		return $this->_pagination;
	}

	private function &search($value='',$columnName='title', $categorieId=0){
		$query = 'SELECT ldlinks.*'
				. ' FROM #__ldlinks as ldlinks '
				. ' WHERE ' . $columnName . ' = ' . $this->_db->Quote($value)
				. ' AND catid = ' .intval($categorieId);
		$this->_db->setQuery($query);	
		$links = $this->_db->loadObjectList();
		return $links;
	}
	
	public function import(){
		
		$parent_id = JRequest::getInt('catid',0);
		
		$db	=& JFactory::getDBO();
		$query = "SELECT weblinks.*, c.title as categoryTitle, c.description as categoryDescription "
				. " FROM #__weblinks as weblinks"
				. " LEFT JOIN #__categories as c ON c.id = weblinks.catid"
				. " ORDER BY c.name, weblinks.title";
		$db->setQuery($query);	
		$links = $db->loadObjectList();
		
		$prevCategoryTitle = "";
		$catId = 0;
		
		echo '<ul>';
		foreach ($links as $link) {
			if ($link->categoryTitle != $prevCategoryTitle) {
				$prevCategoryTitle = $link->categoryTitle;
				$model4WebCategory = JModel::getInstance('webcategory','LinkDirectory2Model');
				$found = $model4WebCategory->searchByName($link->categoryTitle, $parent_id);
				if ($found){
					$catId = $found->id;
					echo '<li style="list-style-image:url('. JURI::base().'/components/com_linkdirectory2/images/cancel_f2.png)">' . JText::sprintf('Found category', $link->categoryTitle) .'</li>';
				} else {
					$caterory = $model4WebCategory->getData();
					$caterory->title = $link->categoryTitle;
					$caterory->name = $link->categoryTitle;
					$caterory->description = $link->categoryDescription;
					$caterory->parent_id = $parent_id;
					$caterory->published = 0;
					$catId = $model4WebCategory->insert(get_object_vars($caterory));
					?><li style="list-style-image:url(./images/tick.png)"><?php echo JText::sprintf('Create new category', $link->categoryTitle);?></li><?php 
				}
			}
			if ( $this->search($link->url,'url', $catId)){
				echo '<li style="list-style-image:url('. JURI::base().'/components/com_linkdirectory2/images/cancel_f2.png)">' . JText::sprintf('Found link', $link->title , $link->url) .'</li>';
				continue;
			}
			$model4WebLink=JModel::getInstance('weblink','LinkDirectory2Model');
			$link->id = 0;
			$link->catid = $catId;
			$link->published = 0;
			$result = $model4WebLink->store(get_object_vars($link));
			if ($result){
				echo '<li style="list-style-image:url(./images/tick.png)"> ' . JText::sprintf('Add new link', $link->title, $link->url).'</li>';
			} else {
				echo '<li style="list-style-image:url('. JURI::base().'/components/com_linkdirectory2/images/cancel_f2.png)">' . JText::sprintf('Can not add link',$link->title, $link->url ) . '</li>';
			}
		}
		echo '</ul>';
	}

	private function _buildQuery() {
		$where		= $this->_buildContentWhere();
		$orderby	= $this->_buildContentOrderBy();
		$query = ' SELECT a.id,a.title,a.published,a.ordering,a.hits, a.modified, a.created, a.catid, a.checked_out, cc.name AS category, u.name AS editor '
			. ' FROM #__ldlinks AS a '
			. ' LEFT JOIN #__ldcats AS cc ON cc.id = a.catid '
			. ' LEFT JOIN #__users AS u ON u.id = a.checked_out '
			. $where
			. $orderby
		;
		return $query;
	}

	private function _buildContentOrderBy() {
		global $option;
		$mainframe = JFactory::getApplication();
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'links'.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'links'.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		if ($filter_order == 'a.ordering'){
			$orderby 	= ' ORDER BY category, a.ordering '.$filter_order_Dir . ', a.title';
		} else {
			$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' , category, a.ordering ';
		}
		return $orderby;
	}

	private function _buildContentWhere() {
		global $option;
		$mainframe = JFactory::getApplication();
		$db					=& JFactory::getDBO();
		$filter_state		= $mainframe->getUserStateFromRequest( $option.'links'.'filter_state',		'filter_state',		'',				'word' );
		$filter_catid		= $mainframe->getUserStateFromRequest( $option.'links'.'filter_catid',		'filter_catid',		0,				'int' );
		$search				= $mainframe->getUserStateFromRequest( $option.'links'.'search',			'search',			'',				'string' );
		$search				= JString::strtolower( $search );
		
		$where = array();
		if ($filter_catid > 0) {
			$where[] = 'a.catid = '.(int) $filter_catid;
		}
		if ($search) {
			$where[] = 'LOWER(a.title) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$where[] = 'a.published = 1';
			} else if ($filter_state == 'U' ) {
				$where[] = 'a.published = 0';
			}
		}
		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );
		return $where;
	}
}
