<?php defined('_JEXEC') or die('Restricted access');

/**
 * @version 2.0 $Id: link.php,v 1.3 2010-02-15 20:26:17 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

class TableLink extends JTable {
	public $id = null;
	public $catid = null;
	public $title = null;
	public $url = null;
	public $thumburl = null;
	public $image = null;
	public $description = null;
	public $description_long = null;
	public $created = null;
	public $modified = null;
	public $hits = null;
	public $rating = null;
	public $votes = null;
	public $published = null;
	public $checked_out = null;
	public $checked_out_time = null;
	public $ordering = null;
	public $params = null;
	
	public function __construct(& $db) {
		parent::__construct('#__ldlinks', 'id', $db);
	}

	public function bindForAdd($array, $ignore = ''){
		$ignore =array ('id' , 'thumburl', 'image', '$created', 'modified',
						'hits','rating','votes','checked_out','checked','ordering','params');		
		return $this->bind($array, $ignore);
	}
	public function bind($array, $ignore = '') {
		if (key_exists( 'params', $array ) && is_array( $array['params'] )) {
			$registry = new JRegistry();
			$registry->loadArray($array['params']);
			$array['params'] = $registry->toString();
		}
		
		$user 	=& JFactory::getUser();
		if  ($user->gid > 18 )  {
				$array['description_long'] = JRequest::getString('description_long','','post',JREQUEST_ALLOWHTML);
		} else {
			$array['published'] = false;
		}
		return parent::bind($array, $ignore);
	}

	/**
	 * Überprüft, ob
	 * - Titel nicht leer isr
	 * - Url syntaktisch nicht fehlerhaft ist
	 *
	 * @return false, wenn check nicht erfolgreich
	 */
	public function check() {
		if (JFilterInput::checkAttribute(array ('href', $this->url))) {
			$this->setError( JText::_('WEBLINK ITEM MUST HAVE A URL'));
			return false;
		}
		if (trim($this->title) == '') {
			$this->setError(JText::_('WEBLINK ITEM MUST HAVE A NAME'));
			return false;
		}
		if (trim($this->url) == '') {
			$this->setError(JText::_('WEBLINK ITEM MUST HAVE A URL'));
			return false;
		}
		if (trim($this->catid) == '') {
			$this->setError(JText::_('WEBLINK NEED A WEBCATEGORY'));
			return false;
		}
		if (!(eregi('http://', $this->url) || (eregi('https://', $this->url)) || (eregi('ftp://', $this->url)))) {
			$this->url = 'http://'.$this->url;
		}
		return true;
	}
}
